<?php

class Lucipress {

// hardcoded variables
var $pre = "FTPod1_";
var $ad_title = "Lucipress options";
var $post_template;

// variables stored in database
var $ftp_user = "";
var $ftp_password = "";
var $ftp_server = "";
var $ftp_path = "";
var $ftp_newlocation = "done/";
var $files_uri = "";

// array of variables stored in database
var $db_vars = array('ftp_server','ftp_user','ftp_password','ftp_path','ftp_newlocation','files_uri');

function load_options () {

	foreach ($this->db_vars as $db_var) {

		$this->$db_var = get_option($this->pre.$db_var);

	}

}

function load_post_options ($post_options) {

	foreach ($this->db_vars as $db_var) {

		$this->$db_var = $post_options[$this->pre.$db_var];

	}

}

function save_options () {

	foreach ($this->db_vars as $db_var) {

		update_option($this->pre.$db_var,$this->$db_var);

	}

}

function create_options () {

	foreach ($this->db_vars as $db_var) {
		
		if (get_option($this->pre.$db_var)){

			add_option($this->pre.$db_var,$this->$db_var);
		
		}

	}

}

function print_options() {

	foreach ($this->db_vars as $db_var) {
		
		echo "\t\t\t\t\t";
		echo '<tr>'; 	
	
		echo '<td>';
		echo $db_var;
		echo '</td>';
	
		echo '<td>';
		echo '<input type="text" name="';
		echo $this->pre.$db_var;
		echo '" value="';
		echo $this->$db_var;
		echo '" />';
		echo '</td>';

		echo '</tr>';
		echo "\n";
	}

}

function set_var ($option,$value) {

	$this->$option = $value;

}

/**
  * This function takes the content of the message - looks for a subject at the begining surrounded by # and then removes that from the content
  * From Postie
  */
function ParseInMessageSubject() {
    if (substr($this->content,0,1) != "#") {
        return;
    }
    $subjectEndIndex = strpos($this->content,"#",1);
    if ($subjectEndIndex > 0) {
      $this->title = substr($this->content,1,$subjectEndIndex - 1);
	$content = $this->content;
	$this->content = substr($content,$subjectEndIndex + 1,strlen($content));
    }
}


function insert_podpost($podpost) {

	global $wpdb;

	$this->post_template ='[image][text]<p class="FP_clear">&nbsp;</p>[images][files][mp2][video]'; 
	
	if ($podpost['text']) {
		$text = "<p align =\"left\" class=\"FP_text\">".$wpdb->escape(htmlentities($podpost['text'], ENT_QUOTES))."</p>";
		$this->post_template = preg_replace ('/\[text\]/',$text,$this->post_template);
	} else {
		$this->post_template = preg_replace ('/\[text\]/','',$this->post_template);
	}

	if ($podpost['files']['mp2'][0]) {
	
		
		$mp2 = $this->files_uri."/".$this->ftp_newlocation."/".$podpost['files']['mp2'][0];
		$mp2_tag = "[mp2=".$mp2."]";
		
		$this->post_template = preg_replace ('/\[mp2\]/',$mp2_tag,$this->post_template);
		// activate when podpress supports mp2:
		//$podPressMedia[0][URI] = $mp2;
		//$podPressMedia[0][type] = 'audio_mp2';
	} else {
		$this->post_template = preg_replace ('/\[mp2\]/','',$this->post_template);
	}
	
	if ($podpost['files']['video'][0]) {
	
		
		$video = $this->files_uri."/".$this->ftp_newlocation."/".$podpost['files']['video'][0];

		$video_tag = "<p class=\"FP_3gp\">[3gp=".$video."]</p>";
		$this->post_template = preg_replace ('/\[video\]/',$video_tag,$this->post_template);

		//activate when podpress supports 3gp:
		//$podPressMedia[0][URI] = $video;
		//$podPressMedia[0][type] = 'video_3gp';
	} else {
		$this->post_template = preg_replace ('/\[video\]/','',$this->post_template);
	}
	
	if ($podpost['files']['image'][0]) {

		if ($podpost['files']['thumb'][0]) {
			$t_image = $podpost['files']['thumb'][0];
		} else {
			$t_image = $podpost['files']['image'][0];
		}

	
		$image = "<p align=\"right\" class=\"FP_image\"><a href=\"".$this->files_uri."/".$this->ftp_newlocation."/".$podpost['files']['image'][0]."\" ><img align=\"right\" src=\"".$this->files_uri."/".$this->ftp_newlocation."/".$t_image."\" /></a></p>";
		$this->post_template = preg_replace ('/\[image\]/',$image,$this->post_template);
	
	} else {
	
		$this->post_template = preg_replace ('/\[image\]/','',$this->post_template);
	
	}
	
	if ($podpost['files']['image'][1]) {
	
		$images="";
	
		foreach ($podpost['files']['image'] as $i => $image) {

			if ($podpost['files']['thumb'][$i]) {
				$t_image = $podpost['files']['thumb'][$i];
			} else {
				$t_image = $image;
			}

			if ($i != 0) {
				$images .= "<p class=\"FP_images\"><a href=\"".$this->files_uri."/".$this->ftp_newlocation."/".$image."\" ><img src=\"".$this->files_uri."/".$this->ftp_newlocation."/".$t_image."\" /></a></p>";
			}
		}
		
		$this->post_template = preg_replace ('/\[images\]/',$images,$this->post_template);
		
	} else {
	
		$this->post_template = preg_replace ('/\[images\]/','',$this->post_template);
	
	}
	
	if ($podpost['files']['other'][0]) {
	
		$files="";
		
	
		foreach ($podpost['files']['other'] as $file) {
				$files .= "<p class=\"FP_files\"><a href=\"".$this->files_uri."/".$this->ftp_newlocation."/$file\" >$file</a></p>";
		}
		
		$this->post_template = preg_replace ('/\[files\]/',$files,$this->post_template);
		
	} else {
	
		$this->post_template = preg_replace ('/\[files\]/','',$this->post_template);
	
	}
	
	
	$post_content = $this->post_template; 
	
	//$podPressPostSpecific = Array
//(
//   'itunes:subtitle' => '##PostExcerpt##',
//    'itunes:summary' => '##PostExcerpt##',
//    'itunes:keywords' => '##WordPressCats##',
//    'itunes:author' => '##Global##',
//    'itunes:explicit' => 'Default',
//    'itunes:block' => 'Default'
//);
	
	
	
	wp_insert_post(
		array(
		'post_title'		=> $podpost[title],
		'post_content'		=> $post_content,
		'post_status'		=> 'publish',
		'post_type' 		=> 'post',
		'post_category'		=> array('post_category' => 63) 
		)						
	);
	
	$query = "SELECT ID FROM $wpdb->posts ORDER BY ID desc";
	
	$postid = $wpdb->get_col($query);
	
	// Hack to get style info in posts
	$query = "UPDATE $wpdb->posts SET post_content = '$post_content' WHERE ID = '$postid[0]' ";
	$wpdb->query($query);
	
	//add_post_meta($postid[0],'podPressMedia',$podPressMedia,false);
	//add_post_meta($postid[0],'podPressPostSpecific',$podPressPostSpecific,false);
	
}

function insert_podposts() {

	$podposts = $this->get_podposts();

	foreach ($podposts as $podpost) {

		$this->insert_podpost($podpost);
	
	}

}

function get_podposts() {

#
# prepare
#
#	$url = get_settings('home')."/wp-luci/thumb.php?return_image=1";
#	echo "<img src='$url' width='1' height='1'>";
	$url = $this->files_uri."/thumb.php";
//	echo "<iframe src='$url' name='mailiframe' width='0' height='0' frameborder='0' scrolling='no' title='Get new Lucipress podcast(s)'>";
	echo "$url<br />";
/*	echo "<script type='text/php' src='http://www.luci.fm/eyeballs/wp-luci/thumb.php'> </script>";*/
//	$thisFile = file_get_contents('$url');
//	echo $thisFile;

// 	echo "<img src=$url >";
	//readfile("php://filter/resource=".'$url');
	exec("/usr/bin/wget $url"); 

require "ftp.class.php";
$ftp = new ClsFTP($this->ftp_user,$this->ftp_password,$this->ftp_server); 
if( $this->ftp_path != '')$ftp->cd($this->ftp_path);
$newposts = array();
$newfiles = array();
$postfiles = array();
$podposts = array();

#
# get list of files
#
if ($files = $ftp->nlist()) {

#
# seperate txt files from other files 
#
foreach($files as $file) {

	if (preg_match('/(.*)\.(.*)/',$file,$match)) {
			
		if ($match[2] == 'txt') {

			array_push($newposts,$match[1]);

		} else {
		
			array_push($newfiles,$match[0]);
		
		}
		
	}	
	
}

#
# build podposts array 
#
$i = 0;
foreach ($newposts as $newpost) {
	// get title from text file name, just in case
	$this->title = $newpost;
	
	// get post text and title from text
	$this->content = '';
	$oldfilename = $newpost.".txt";
	$newfilename = "cache/".$i.".txt";
	$ftp->get($newfilename,$oldfilename);
	$fh = fopen($newfilename, 'r') or die("Can't open file");
	if (filesize($newfilename)) {
		$this->content = fread($fh, filesize($newfilename));
		// take title out of content
		$this->ParseInMessageSubject();
	}
	fclose($fh);
	unlink($newfilename);

	$podposts[$i]['title'] = $this->title;
	$podposts[$i][text] = $this->content;
	
	// move text file
	$newname = $this->ftp_newlocation."/".$oldfilename;
	$ftp->rename_file($oldfilename,$newname);
	
	
	// get associated files
	$podposts[$i][files][mp2] = array();
	$podposts[$i][files][image] = array();
	$podposts[$i][files][video] = array();
	$podposts[$i][files][other] = array();
	$podposts[$i][files][thumb] = array();

	$filematch = "/^(tn_)?$newpost(_[ 0-9][ 0-9])?\.(...)$/";

	foreach($newfiles as $newfile) {

		if (preg_match($filematch,$newfile,$match)) {
		
			switch($match[3]) {
			
				case 'wav':
				case 'mpa':
				case 'mp2':
				case 'mpg':
				case 'mp3':
					array_push($podposts[$i][files][mp2],$newfile);
					break;
				case 'mp4';
				case '3gp':
					array_push($podposts[$i][files][video],$newfile);
					break;	
				case 'jpg':
				case 'JPG':
				case 'jpeg':
				case 'JPEG':
				case 'png':
					if (substr($match[0], 0, 3) == 'tn_') {
						array_push($podposts[$i][files][thumb],$newfile);
					} else {
						array_push($podposts[$i][files][image],$newfile);
					}
					break;

				default:
					array_push($podposts[$i][files][other],$newfile);

			}
			
			$newname = $this->ftp_newlocation."/".$newfile;
			$ftp->rename_file($newfile,$newname); // comment out during testing
					
			
		}
		
	}
	
	$i++;
	
}


#
# debug
#

echo "Files<br />";
$ftp->p($files);
echo "Newposts<br />";
$ftp->p($newposts);
echo "Newfiles<br />";
$ftp->p($newfiles);
echo "Podposts<br />";
$ftp->p($podposts);

return $podposts;

} else { // end if file list

	die('Cannot get filelist from ftp server. Firewall?');
	
}

}

function mp2tag_replace($URL) {
	global $post;
  	$winContent = "<object width='300' height='42' codetype='application/x-mplayer2'>";
	$winContent .= "<param name='src' value='".$URL."'>";
    $winContent .= "<param name='autoStart' value='0'>";
    $winContent .= "<param name='autoplay' value='false'>";
    $winContent .= "<param name='controller' value='true'>";
    $winContent .= "<param name='bgcolor' value='#FFFFFF'>";
    $winContent .= "<embed src='".$URL."' autoStart='0' autoplay='false' loop='false' width='300' height='16' controller='true' bgcolor='#FFFFFF'></embed>";
    $winContent .= "</object>";
	return $winContent;

}

function gptag_replace($URL) {

	$embed = '<object
   classid="clsid:02BF25D5-8C17-4B23-BC80-D3488ABDDC6B"
   width="176" height="158"
   codebase="http://www.apple.com/qtactivex/qtplugin.cab"
   standby="Loading Media Player...">
   <param name="src"
   value="'.$URL.'">
   <param name="autoplay" value="false">
   <param name="controller" value="true">
   <param name="loop" value="false">
   <param name="type" value="video/quicktime">
    <embed
     src="'.$URL.'"
     width="176" height="158"
     autoplay="false"
     controller="true"
     loop="false"
     type="video/quicktime"
     pluginspage="http://www.apple.com/quicktime/download/"
    >
    </embed>
</object>';

	//$embed = "<embed src =\"$URL\" autostart=\"false\" loop=\"false\" type=\"video/quicktime\" pluginspage=\"http://www.apple.com/quicktime/download/\"/>";
	
	$embed = '<script type="text/javascript">
			// <![CDATA[
			var myQTObject = new QTObject("'.$URL.'", "'.$URL.'", "320", "240");
			myQTObject.addParam("autostart", "false");
			myQTObject.write();
			// ]]>
		</script>
		<noscript>
			<p>You must enable Javascript to view this content, or you can. <a href="'.$URL.'">download this video</a>.</p>
		</noscript>
			';
	return $embed; //

}

} // end class

?>
